#include "ImageType.h"

CImgType::CImgType()
{
	m_imgptr = NULL;
	m_isanimated = 0;
}

void CImgType::ProcessInFile(char *filename)
{
	CTString str = filename;
	str.ToUpper();

	m_isanimated = 0;
	if(str.Find(".JPG") > -1)
	{
		m_jpg.ProcessInFile(filename);
		m_imgptr = m_jpg.GetImage();
		m_x = m_jpg.GetX();
		m_y = m_jpg.GetY();
	}
	else if(str.Find(".BMP") > -1)
	{
		m_bmp.ProcessInFile(filename);
		m_imgptr = m_bmp.GetImage();
		m_x = m_bmp.GetX();
		m_y = m_bmp.GetY();
	}
	else if(str.Find(".PCX") > -1)
	{
		m_pcx.ProcessInFile(filename);
		m_imgptr = m_pcx.GetImage();
		m_x = m_pcx.GetX();
		m_y = m_pcx.GetY();
	}
	else if(str.Find(".TIF") > -1)
	{
		m_tiff.ProcessInFile(filename);
		m_imgptr = m_tiff.GetImage();
		m_x = m_tiff.GetX();
		m_y = m_tiff.GetY();
	}
	else if(str.Find(".GIF") > -1)
	{
		m_gif.ProcessInFile(filename);
		m_imgptr = m_gif.GetImage();
		m_x = m_gif.GetX();
		m_y = m_gif.GetY();
		if(m_gif.Frames() > 1)
			m_isanimated = 1;
		m_delay = m_gif.Delay();
	}
}

char *CImgType::GetImage()
{
	if(m_isanimated)
		return m_gif.GetImage();

	return m_imgptr;
}

int CImgType::GetX()
{
	return m_x;
}

int CImgType::GetY()
{
	return m_y;
}
