// JPGEngIView.cpp : implementation of the CJPGEngIView class
//

#include "stdafx.h"
#include "JPGEngI.h"

#include "JPGEngIDoc.h"
#include "JPGEngIView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CJPGEngIView

IMPLEMENT_DYNCREATE(CJPGEngIView, CView)

BEGIN_MESSAGE_MAP(CJPGEngIView, CView)
	//{{AFX_MSG_MAP(CJPGEngIView)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJPGEngIView construction/destruction

CJPGEngIView::CJPGEngIView()
{
	// TODO: add construction code here
	m_timer = 0;
}

CJPGEngIView::~CJPGEngIView()
{
}

BOOL CJPGEngIView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CJPGEngIView drawing

void CJPGEngIView::OnDraw(CDC* pDC)
{
	CJPGEngIDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here

	char *img = pDoc->m_imgeng.GetImage();
	if(img)
	{
		if(pDoc->m_imgeng.Animated())
		{
			if(m_timer)
				KillTimer(0);
			SetTimer(0, pDoc->m_imgeng.AnimDelay() * 10, NULL);
			m_timer = 1;
		}
		else if(m_timer)
		{
			KillTimer(0);
			m_timer = 0;
		}

		BITMAPINFO bitsinfo;
		bitsinfo.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
		bitsinfo.bmiHeader.biWidth = pDoc->m_imgeng.GetX();
		bitsinfo.bmiHeader.biHeight = -pDoc->m_imgeng.GetY();
		bitsinfo.bmiHeader.biPlanes = 1;
		bitsinfo.bmiHeader.biBitCount = 24;
		bitsinfo.bmiHeader.biCompression = BI_RGB;
		bitsinfo.bmiHeader.biSizeImage = 0;
		bitsinfo.bmiHeader.biXPelsPerMeter = 100;
		bitsinfo.bmiHeader.biYPelsPerMeter = 100;
		bitsinfo.bmiHeader.biClrUsed = 0;
		bitsinfo.bmiHeader.biClrImportant = 0;

		CRect rect;
		GetClientRect(&rect);
		StretchDIBits(pDC->m_hDC,
			rect.left,
			rect.top,
			rect.Width(),
			rect.Height(),
			0,
			0,
			pDoc->m_imgeng.GetX(),
			pDoc->m_imgeng.GetY(),
			img,
			&bitsinfo,
			DIB_RGB_COLORS,
			SRCCOPY);

		/*char *img = pDoc->m_imgeng.GetImage();
		int totalx, totaly, x, y, idx;
		idx = 0;
		totalx = pDoc->m_imgeng.GetX();
		totaly = pDoc->m_imgeng.GetY();

		CRect rect;
		GetClientRect(&rect);

		if(rect.Width() == 0 || rect.Height() == 0)
			return;	// Don't draw anything.

		int skipx, skipy, oldx;
		skipx = totalx / rect.Width();
		skipy = totaly / rect.Height();
		oldx = totalx;
		totalx /= (1 + skipx);
		totaly /= (1 + skipy);

		for(y = 0; y < totaly; y++)
		{
			for(x = 0; x < totalx; x++)
			{
				COLORREF crColor = RGB(img[idx], img[idx + 1], img[idx + 2]);
				pDC->SetPixelV(x, y, crColor);
				idx += 3 * (1 + skipx);
			}
			idx += 3 * (oldx * skipy + (oldx % totalx));
		}*/
	}
}

/////////////////////////////////////////////////////////////////////////////
// CJPGEngIView printing

BOOL CJPGEngIView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CJPGEngIView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CJPGEngIView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CJPGEngIView diagnostics

#ifdef _DEBUG
void CJPGEngIView::AssertValid() const
{
	CView::AssertValid();
}

void CJPGEngIView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CJPGEngIDoc* CJPGEngIView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CJPGEngIDoc)));
	return (CJPGEngIDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CJPGEngIView message handlers


void CJPGEngIView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(m_timer)
		Invalidate(false);
	else
		Invalidate();

	CView::OnTimer(nIDEvent);
}

BOOL CJPGEngIView::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	if(m_timer)
		KillTimer(0);
	
	return CView::DestroyWindow();
}
