///////////////////Software Control Header///////////////////////////////////
// BMPLib.h - Library to support BMP encoding/decoding engine.
//
// $LogThisFile$ \Projects\UtilCode\Include\BMPLib.h
// 
// V01.00 19/10/2002 1707
//  Initial revision.
// 
// This code is freely distributed to help the development of complex
// software in any field using C++. The author is not held responsible
// for any damage caused by the usage of the code.
// The author should be acknowledged for the use of this piece of code in
// commercial software.
//
// Bug reports and suggestions are welcomed to report to
//
//          tzzstan@hotmail.com
/////////////////////////////////////////////////////////////////////////////
#ifndef __BMP_LIB__
#define __BMP_LIB__

#include "TString.h"
#include "BitStrm.h"

class CBMPEngine
{
	long m_bfSize, m_bfOffBits;
	long m_biSize, m_biWidth, m_biHeight, m_biPlanes,
		m_biBitCount, m_biCompression, m_biSizeImage, m_biXPelsPerMeter,
		m_biYPelsPerMeter, m_biClrUsed, m_biClrImportant;
	char *m_image, *m_table;
	CBitStream *m_iobits;

	////////////////////////////////////////////////////////
	//                Decoder                             //
	////////////////////////////////////////////////////////
	void Decompress4();
	void Decompress8();
	void LoadUncompress();

	////////////////////////////////////////////////////////
	//                Shared                              //
	////////////////////////////////////////////////////////
	int LittleEnd(int data, int bytes);
	void Reset();

public:
	enum bmpmodes {
		bi_rgb = 0x0000,
		bi_rle8 = 0x0001,
		bi_rle4 = 0x0002
	};

	CBMPEngine();
	~CBMPEngine();

///////////////////
// Data retrieval
///////////////////
	int GetX();
	int GetY();
	char *GetImage();

///////////////////
// Modifiers
///////////////////
	void ProcessInFile(char *filename);
};

#endif