///////////////////Software Control Header///////////////////////////////////
// PCXLib.h - Library to support PCX encoding/decoding engine.
//
// $LogThisFile$ \Projects\UtilCode\Include\PCXLib.h
// 
// V01.00 10/11/2002 1104
//  Add SetNewImage().
// 
// This code is freely distributed to help the development of complex
// software in any field using C++. The author is not held responsible
// for any damage caused by the usage of the code.
// The author should be acknowledged for the use of this piece of code in
// commercial software.
//
// Bug reports and suggestions are welcomed to report to
//
//          tzzstan@hotmail.com
/////////////////////////////////////////////////////////////////////////////
#ifndef __PCX_LIB__
#define __PCX_LIB__

#include "TString.h"
#include "BitStrm.h"

/////////////////////////////////////////////////////////////////////////////
// CPCXEngine
//
// Desctiption: Engine to decode/encode PCX bitstream.
//
// TSTan   20 Oct 2002
/////////////////////////////////////////////////////////////////////////////
class CPCXEngine
{
	long m_manufacturer,	m_version, m_encoding,
		m_bitsperpixel, m_xmin, m_ymin,
		m_xmax, m_ymax, m_hdpi,
		m_vdpi, m_nplanes, m_bytesperline,
		m_paletteinfo,	m_hscreensize,	m_vscreensize;
	char *m_image, *m_table;
	CBitStream *m_iobits;

	////////////////////////////////////////////////////////
	//                Decoder                             //
	////////////////////////////////////////////////////////
	void DecodeLine(char *buffer);
	void Decompress(char *imgbuf);
	void Decompress8();

	////////////////////////////////////////////////////////
	//                Shared                              //
	////////////////////////////////////////////////////////
	int LittleEnd(int data, int bytes);
	void Reset();

public:

	CPCXEngine();
	~CPCXEngine();

///////////////////
// Data retrieval
///////////////////
	int GetX();
	int GetY();
	char *GetImage();

///////////////////
// Modifiers
///////////////////
	void ProcessInFile(char *filename);
	void SetNewImage(char *img, int x, int y);
};

#endif